#include "ilua.h"
#include "instancevars.h"

static int ilua_gwait(lua_State *L){ /* undocumented wait function in testing */
	clock_t endwait;
	endwait = clock () + lua_tonumber(L,1) * CLOCKS_PER_SEC ;
	while (clock() < endwait) {}
	return 0;
}

static int ilua_settitle(lua_State *L){
	if (lua_isstring(L,2)) {
		[ilua_mainwindow setTitle: [NSString stringWithUTF8String:lua_tostring(L,2)]];
	}else{
		luaL_typerror(L,2,"string");
	}
	return 0;
}

static int ilua_setfont(lua_State *L){
	if (lua_isstring(L,2)&&lua_isnumber(L,3)&&
	[[[NSFontManager sharedFontManager] availableFontFamilies] containsObject:[NSString stringWithUTF8String:lua_tostring(L,2)]]==YES){
		[ilua_inputview setFont:[NSFont fontWithName:[NSString stringWithUTF8String:lua_tostring(L,2)] size:lua_tonumber(L,3)]];
		[ilua_outputview setFont:[NSFont fontWithName:[NSString stringWithUTF8String:lua_tostring(L,2)] size:lua_tonumber(L,3)]];
		[ilua_helpview setFont:[NSFont fontWithName:[NSString stringWithUTF8String:lua_tostring(L,2)] size:lua_tonumber(L,3)]];
	}
	return 0;
}

static int ilua_close(lua_State *L){
	[ilua_mainwindow performClose:0];
	return 0;
}

static int ilua_openhelp(lua_State *L){
	[ilua_helpwindow orderFront:0];
	return 0;
}

static const luaL_Reg ilualib[]={
	{"SetFont",ilua_setfont},
	{"SetTitle",ilua_settitle},
	{"Close",ilua_close},
	{"ShowHelp",ilua_openhelp},
	{NULL,NULL}
};

LUALIB_API int luaopen_ilua(lua_State *L){
	lua_register(L,"wait",ilua_gwait);
	luaL_register(L,ILUA_LIBNAME,ilualib);
	lua_pushstring(L,ILUA_VERSION);
	lua_setfield(L,2,"version");
	return 1;
}