#import "interface.h"
#include "ilua.h"
#include "instancevars.h"

/*************GET INSTANCES************************/

NSWindow *ilua_mainwindow;
NSWindow *ilua_helpwindow;
NSTextView *ilua_inputview;
NSTextView *ilua_helpview;
NSTextView *ilua_outputview;

/*************************************************/

@implementation interface

- (IBAction)resetLuaStateClicked:(id)sender{
	if (GL!=NULL){
		lua_close(GL);
		ilua_startlua();
	}
}
- (IBAction)clearProgramClicked:(id)sender{
	[inputView selectAll:0];
	[inputView delete:0];
}

- (IBAction)clearOutputClicked:(id)sender{
	[outputView selectAll:0];
	[outputView delete:0];
}

- (IBAction)runProgramClicked:(id)sender{
	[progressIndicator setHidden:NO];
	[outputView setString: @""];
	[progressIndicator startAnimation:sender];
	ilua_runcode([[inputView string] UTF8String]);
	[progressIndicator stopAnimation:sender];
	[progressIndicator setHidden:YES];	
}

- (void)awakeFromNib{
	[inputView setString:@"print(\"Hello, World!\")"]; /* the best way to start! */
	[inputView setFont:[NSFont fontWithName:@"Courier" size:12]];
	[outputView setFont:[NSFont fontWithName:@"Courier" size:12]];
	[helpView setFont:[NSFont fontWithName:@"Courier" size:12]];
	ilua_outputview=outputView;
	ilua_helpview=helpView;
	ilua_mainwindow=mainWindow;
	ilua_inputview=inputView;
	ilua_helpwindow=helpWindow;
}

@end
	